<?php

namespace Payroll\Piece\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Payroll\Piece\Interfaces\PieceRepositoryInterface;

class PiecePublicController extends BaseController
{
    // use PieceWorkflow;

    /**
     * Constructor.
     *
     * @param type \Payroll\Piece\Interfaces\PieceRepositoryInterface $piece
     *
     * @return type
     */
    public function __construct(PieceRepositoryInterface $piece)
    {
        $this->repository = $piece;
        parent::__construct();
    }

    /**
     * Show piece's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $pieces = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('piece::public.piece.index', compact('pieces'))->render();
    }

    /**
     * Show piece.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $piece = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('piece::public.piece.show', compact('piece'))->render();
    }

}
