<?php

namespace Payroll\Piece;

use User;

class Piece
{
    /**
     * $piece object.
     */
    protected $piece;

    /**
     * Constructor.
     */
    public function __construct(\Payroll\Piece\Interfaces\PieceRepositoryInterface $piece)
    {
        $this->piece = $piece;
    }

    /**
     * Returns count of piece.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.piece.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->piece->pushCriteria(new \Litepie\Payroll\Repositories\Criteria\PieceUserCriteria());
        }

        $piece = $this->piece->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('piece::' . $view, compact('piece'))->render();
    }
}
