<?php

namespace Payroll\Piece\Workflow;

use Payroll\Piece\Models\Piece;
use Payroll\Piece\Notifications\Piece as PieceNotifyer;
use Notification;

class PieceNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function complete(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function verify(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function approve(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function publish(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function archive(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Piece $piece
     *
     * @return void
     */
    public function unpublish(Piece $piece)
    {
        return Notification::send($piece->user, new PieceNotifyer($piece, 'unpublish'));;

    }
}
